package com.primeton.dsp.datarelease.data.bdata;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * hive 测试连接
 *
 * <pre>
 *
 * Created by zhaopx.
 * User: zhaopx
 * Date: 2020/4/21
 * Time: 17:59
 *
 * </pre>
 *
 * @author zhaopx
 */
public interface HiveConnectionService {


    /**
     * 安全处理，认证. 认证不通过可能抛出 SecurityException
     * @return 返回 true 认证通过
     */
    default public boolean doAuth() { return true; };


    /**
     * 获取一个连接
     * @return
     */
    public Connection getConnection() throws SQLException;
}
