package com.yiidata.amc.common.principal;

import org.apache.hadoop.conf.Configuration;

/**
 * <pre>
 *
 * Created by zhenqin.
 * User: zhenqin
 * Date: 2018/4/23
 * Time: 10:15
 * Vendor: yiidata.com
 * To change this template use File | Settings | File Templates.
 *
 * </pre>
 *
 * @author zhenqin
 */
public abstract class HadoopPrincipal {



    public Configuration getConf(String... res){
        return getPrincipalConf(new Configuration(), res);
    }


    /**
     * 获取认证的配置
     * @param conf Hadoop Conf
     * @param res 多个 site xml 信息
     * @return
     */
    public abstract Configuration getPrincipalConf(Configuration conf, String... res);
}
