package com.yiidata.amc.common.principal;

import org.apache.commons.lang.StringUtils;
import org.apache.hadoop.conf.Configuration;

/**
 *
 * 无加密的
 *
 *
 * <pre>
 *
 * Created by zhenqin.
 * User: zhenqin
 * Date: 2018/4/23
 * Time: 10:15
 * Vendor: yiidata.com
 * To change this template use File | Settings | File Templates.
 *
 * </pre>
 *
 * @author zhenqin
 */
public class NonHadoopPrincipal extends HadoopPrincipal {


    /**
     * 无加密的 Conf
     * @param conf 配置
     * @return
     */
    @Override
    public Configuration getPrincipalConf(Configuration conf, String... res) {
        for (String re : res) {
            if(StringUtils.isBlank(re)) {
                continue;
            }
            conf.addResource(re);
        }
        return conf;
    }
}
