package com.sdyc.ndmp.protobuf.serializer;

/**
 * <pre>
 *
 * Created by IntelliJ IDEA.
 * User: zhenqin
 * Date: 15/2/27
 * Time: 10:58
 * To change this template use File | Settings | File Templates.
 *
 * </pre>
 *
 * @author zhenqin
 */
public abstract class CompressSerializer implements Serializer<byte[]> {


    public CompressSerializer() {
    }


    @Override
    public byte[] serialize(byte[] bytes) {
        return compress(bytes);
    }

    @Override
    public byte[] deserialize(byte[] bytes) {
        return uncompress(bytes);
    }



    public abstract byte[] compress(byte[] bytes);




    public abstract byte[] uncompress(byte[] bytes);
}
