package com.primeton.poctag.service.ldap;

import lombok.Getter;
import lombok.Setter;
import lombok.ToString;
import org.springframework.ldap.odm.annotations.Attribute;
import org.springframework.ldap.odm.annotations.DnAttribute;
import org.springframework.ldap.odm.annotations.Entry;
import org.springframework.ldap.odm.annotations.Id;

import javax.naming.Name;
/**
 * <pre>
 *
 * Created by zhenqin.
 * User: zhenqin
 * Date: 2021/9/14
 * Time: 17:24
 * Vendor: yiidata.com
 * To change this template use File | Settings | File Templates.
 *
 * </pre>
 *
 * @author zhenqin
 */
@Setter
@Getter
@ToString
@Entry(objectClasses = {"top", "person" ,"inetOrgPerson","organizationalPerson"})
public class Person {

    @Id
    private Name dn;

    //必填
    @Attribute(name="cn")
    private String cn;

    @Attribute(name="sn")
    private String sn;

    @Attribute(name="uid")
    private String uid;

    //选填
    @Attribute(name="userPassword")
    private String password;

    @Attribute(name="givenName")
    String givenName;

    @Attribute(name="description")
    String description;
}
