package com.primeton.filetransfer.server.template;

import java.sql.SQLException;

/**
 *
 * JDBC ResultSet 转 Entity Object 快捷方法
 *
 * <pre>
 *
 * Created by zhaopx.
 * User: zhaopx
 * Date: 2022/3/7
 * Time: 下午4:02
 * Vendor: primeton.com
 *
 * </pre>
 *
 * @author zhaopx
 */
public interface ResultTransformer<T> {


    /**
     * 转换
     * @param tuple
     * @param aliases
     * @return
     * @throws SQLException
     */
    public T transformTuple(Object tuple[], String aliases[]) throws SQLException;
}
